package com.hikcreate.drv_photo_pic.impl;

import com.github.tobato.fastdfs.service.FastFileStorageClient;
import com.hikcreate.drv_photo_pic.DrvPhoto;
import com.hikcreate.drv_photo_pic.VaidData;
import com.hikcreate.drv_photo_pic.Vehicle;
import com.hikcreate.entity.DriverPhoto;
import com.hikcreate.service.fdfs.service.FileService;
import com.hikcreate.utils.HbaseUtils;
import org.apache.hadoop.hbase.Cell;
import org.apache.hadoop.hbase.CellUtil;
import org.apache.hadoop.hbase.client.Result;
import org.apache.hadoop.hbase.client.ResultScanner;
import org.apache.hadoop.hbase.client.Scan;
import org.apache.hadoop.hbase.client.Table;
import org.apache.hadoop.hbase.filter.*;
import org.apache.hadoop.hbase.util.Bytes;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.List;

@Service("vaidDataImpl")
public class VaidDataImpl implements VaidData {

    private static Logger logger = LoggerFactory.getLogger(VaidDataImpl.class);

    @Autowired
    private DrvPhoto drvPhoto;
    @Value("${hbase.zookeeper.property.clientPort}")
    private String hbaseAddress;
    @Value("${hbase.zookeeper.quorum}")
    private String hbaseZkQuorum;
    @Autowired
    private HbaseUtils hbaseUtils;
    @Autowired
    private FileService fileService;
    @Autowired
    private Vehicle vehicle;
    /**
     * 校验指定月份的图片长度正常不
     */
    @Override
    public void vaidDataLengthByMon(String tableName, String month) {
        org.apache.hadoop.hbase.client.Connection hbseCon = null;
        Table table = null;
        try {
            hbseCon = hbaseUtils.getHbseCon(hbaseAddress, hbaseZkQuorum);
            table = hbaseUtils.getHbaseTable(hbseCon, tableName);
            FilterList filterList = new FilterList();
            Scan scan = new Scan();
            filterList.addFilter(new SingleColumnValueFilter(Bytes.toBytes("info"), Bytes.toBytes("gxsj"), CompareFilter.CompareOp.EQUAL, new SubstringComparator(month)));
            filterList.addFilter(new SingleColumnValueFilter(Bytes.toBytes("info"), Bytes.toBytes("fzjg"), CompareFilter.CompareOp.EQUAL, new SubstringComparator("贵A")));
//            scan.addColumn(Bytes.toBytes("info"), Bytes.toBytes("picUrl"));
//            scan.addColumn(Bytes.toBytes("info"), Bytes.toBytes("picLen"));
            scan.setFilter(filterList);
//            if("pic:drv_photo".equals(tableName)){
//                scan.addColumn(Bytes.toBytes("info"), Bytes.toBytes("sfzmhm"));
//            }else if("pic:veh_pic_new1".equals(tableName)){
//                scan.addColumn(Bytes.toBytes("info"), Bytes.toBytes("xh"));
//            }
            ResultScanner resultScanner = table.getScanner(scan);
            for (Result result : resultScanner) {
                List<Cell> cells = result.listCells();
                String[] colValue = new String[3];
                for (Cell cell : cells) {
                    String qualifier = Bytes.toString(CellUtil.cloneQualifier(cell));
                    String value = Bytes.toString(CellUtil.cloneValue(cell));
                    if ("picLen".equals(qualifier)) {
                        colValue[0] = value;
                    } else if ("picUrl".equals(qualifier)) {
                        colValue[1] = value;
                    } else if("sfzmhm".equals(qualifier) || "xh".equals(qualifier)){
                        colValue[2] = value;
                    }
                }
                try {
                    byte[] bytes = fileService.downloadFile(colValue[1]);
                    if (!(bytes.length / 1024+"").equals(colValue[0])) {
                        logger.info("校验长度不对：++" + colValue[2]+"+++++++++"+colValue[1]+"----------"+colValue[0]+"-----fastdfs长度------"+bytes.length);
//                    if("pic:drv_photo".equals(tableName)){
//                        drvPhoto.insertDrvPhotoById(colValue[2]);
//                    }else if("pic:veh_pic_new1".equals(tableName)){
//                        vehicle.insertVehPicByXh(colValue[2]);
//                    }
                    }
                }catch (Exception e){
                    logger.info("取图片失败：=========="+colValue[2]+"==图片地址=="+colValue[1]);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            hbaseUtils.closeHbaseTable(table);
            hbaseUtils.clodeHbaseCon(hbseCon);
        }
    }

}
